/* All proprietary functions for math operations (input/output/etc...) */
#include <ctype.h>
#include <string.h>
#include <stdio.h>

/* Round double according to format given by 'form', must be exact 'printf' format (e.g. "%.1lf"). */ 
double round(double v,char *form)
{
double r;
char str[20];

sprintf(str,form,v);
r = atof(str);
return(r);
}


/* puts back last character */
double read_doubleu(FILE *fil)
{
int s,i;
double f, f1, f2, d, sign=1.0;

while(feof(fil) == 0)
{
	 s = getc(fil);
	 if(s >= '0' && s <= '9') goto find;
	 else if(s == '-') sign = -1.;
	 else sign = 1.;
}

return(-1.);

find:

i=s-'0'; f1=i; f2=0.; d=1.;

while(feof(fil) == 0)
{
	  s = getc(fil);
	  if(s >= '0' && s <= '9')
			{i=s-'0'; f=i; f1=f1*10.+f;}
	  else if(s == '.')
				 {
					while(feof(fil) == 0)
					{
						s = getc(fil);
						if(s >= '0' && s <= '9')
									 {i=s-'0'; f=i; f2=f2*10.+f; d=d/10.;}
						else break;
					}
						 break;
				 }
				 else break;
}
ungetc(s,fil);
f = sign * ( f1 + f2 * d );
return f;
}

/********************************/
/* Reading of double from file */
/********************************/
double read_double( FILE *fil)
{
int s,i;
double f, f1, f2, d, sign=1.0;

while(feof(fil) == 0)
{
	 s = getc(fil);
	 if(s >= '0' && s <= '9') goto find;
	 else if(s == '-') sign = -1.;
	 else sign = 1.;
}

return(-1.);

find:

i=s-'0'; f1=i; f2=0.; d=1.;

while(feof(fil) == 0)
{
	  s = getc(fil);
	  if(s >= '0' && s <= '9')
			{i=s-'0'; f=i; f1=f1*10.+f;}
	  else if(s == '.')
				 {
					while(feof(fil) == 0)
					{
						s = getc(fil);
						if(s >= '0' && s <= '9')
									 {i=s-'0'; f=i; f2=f2*10.+f; d=d/10.;}
						else break;
					}
						 break;
				 }
				 else break;
}
if (s == '\n') ungetc(s,fil);
f = sign * ( f1 + f2 * d );
return f;
}


/********************************/
/* Reading of integer from file */
/********************************/

int read_int(FILE *fil)
{
int s, i, sign=1;

while(feof(fil) == 0)
{
	s = getc(fil);
	if(s >= '0' && s <= '9') goto find;
	else if(s == '-') sign = -1;
	else sign = 1;
}

return(0);

find:

i = s - '0';
while(feof(fil) == 0)
{
	s = getc(fil);
	if(s >= '0' && s <= '9') i = i*10 + s - '0';
	else break;
}
if (s == '\n') ungetc(s,fil);
return(i*sign);
}


/********************************/
/* Reading of long integer from file */
/********************************/

long read_long(FILE *fil)
{
int s;
long i, sign=1;

while(feof(fil) == 0)
{
	s = getc(fil);
	if(s >= '0' && s <= '9') goto find;
	else if(s == '-') sign = -1;
	else sign = 1;
}

return(0);

find:

i = s - '0';
while(feof(fil) == 0)
{
	s = getc(fil);
	if(s >= '0' && s <= '9') i = i*10 + s - '0';
	else break;
}
if (s == '\n') ungetc(s,fil);
return(i*sign);
}


/**********************************/
/* Reading of integer from string */
/**********************************/

int sread_int(char *string)
{
char *s1;
int s,i,sign=1;

s1=string;
while((s = *(s1++)) != '\0')
      if(s >= '0' && s <= '9') goto find;
      else if(s == '-') sign = -1;
	   else sign = 1;

return 0;

find: i=s-'0';
while((s = *(s1++)) != '\0') if(s >= '0' && s <= '9') i=i*10+s-'0'; else break;
return(i*sign);
}


/**********************************/
/* Reading of integer from string */
/**********************************/

long sread_long(char *string)
{
char *s1;
int s;
long i,sign=1;

s1=string;
while((s = *(s1++)) != '\0')
      if(s >= '0' && s <= '9') goto find;
      else if(s == '-') sign = -1;
	   else sign = 1;

return 0;

find: i=s-'0';
while((s = *(s1++)) != '\0') if(s >= '0' && s <= '9') i=i*10+s-'0'; else break;
return(i*sign);
}


static double PRECISION[40]=
				  {
				  1,
				  0.1,
				  0.01,
				  0.001,
				  0.0001,
				  0.00001,
				  0.000001,
				  0.0000001,
				  0.00000001,
				  0.000000001,
				  0.0000000001,
				  0.00000000001,
				  0.000000000001,
				  0.0000000000001,
				  0.00000000000001
				  };

/**********************************/
/* Reading of  double  from string */
/**********************************/

double sread_double(char *string)
{
char *s1;
int s,i,j;
double f=0.0, f1=0.0, f2=0.0, sign=1.0;

s1=string;

while( (s = *(s1++)) != '\0')
	 if(s >= '0' && s <= '9') goto find;
	 else if(s == '-') sign = -1.0;
	 else sign = 1.0;

return 0;

find:

j=0; i=s-'0'; f1=i; f2=0.0;

while( (s = *(s1++)) != '\0')
	  if(s >= '0' && s <= '9')
	 {i=s-'0'; f=i; f1=f1*10.0+f;}
	  else if(s == '.')
				 {
				 while( (s = *(s1++)) != '\0')
						if(s >= '0' && s <= '9')
				{i=s-'0'; f=i; f2=f2*10.0+f; j++;}
						else break;
					f2*=PRECISION[j];
				 break;
				 }
			 else break;
f = sign * (f1 + f2);
return f;
}


double read_xyz(char *s)
{
int i;
double tt;
char str[20];

strncpy(str+1,s,20);
str[0] = ' ';
str[19] = '\0';
for(i = 0;;i++) if(isdigit(str[i]) || str[i] == '.' || str[i] == '-') break;
if(str[i] == '.') str[i-1] = '0';
if(str[i] == '-') {str[i] = '0';str[i-1] = '-';} 
tt = sread_double(str+i-1);
return(tt);
}

